﻿--- This manages options, databases, etc.
local Broker_H3DC = LibStub("AceAddon-3.0"):NewAddon("H3 DungeonCooldowns",
											'AceEvent-3.0')

--- This manages all LDB related things.
local H3DC_Object = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_H3DungeonCooldowns", {type = "data source", icon = "Interface\\Addons\\Broker_H3DungeonCooldowns\\icon", label = "Broker H3 DungeonCooldowns"})

--- This will be used incase we need something to update constantly without anything disabling/enabling it.
local H3DC = CreateFrame("Frame", "Broker_H3DungeonCooldowns")

--- Obviously no the database. >.>
local db -- divisor dividend modulusRemainder eightbitNum redNum greenNum blueNum

--- databases and locales
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale("Broker_H3DungeonCooldowns")
local LibQTip = LibStub("LibQTip-1.0")

--- Local Variables
local totaltime2, elapsed2, elapsed, elap = 0, 0, 0, 0
local TOTALTIME = 20
local loopCount = 0
local tooltip
local r, g, b, r2, g2, b2
local roundedReset
local skillLVL, color
local placeHolder
local nameFont, tiphintFont, textFont, subheaderFont, headerFont, headerFont2, whitespaceFont
local curToon, dunCol, exists
local name, id, reset, difficulty, locked, extended, instanceIDMostSig, isRaid, maxPlayers, difficultyName
local hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime
local dunExpansion
local pendingRequestInfo = false
local STARTUPCOMPLETE = false
local toonName_, serverName_
local dpsIcon1, dpsIcon2, dpsIcon3, healerIcon, tankIcon
local tankIcon_,healerIcon_,guideIcon_,dpsIcon_
local isLeader, isTank, isHealer, isDPS, rolesString, awtString, roleIconStr
local isLeader, role, level, responded, accepted, name, class
local proposalExists, typeID, id, name, texture, role, hasResponded, totalEncounters, completedEncounters, numMembers, isLeader
local someoneDidntAccept, dungeonInviteCurString
local inInstance, instanceType

local expHeaderOptions = {}
expHeaderOptions["NONE"] = "None"
expHeaderOptions["NAME"] = "Expansion Name"
expHeaderOptions["WHITESPACE"] = "Whitespace"

---FUNCTION OVERRIDES---
-- Re define print so we don't have to do a string format every time we want our print to look different. --
local print = function(...) print(string.format("|cff%02x%02x%02x%s|r %s",130,130,200,"H3DungeonCooldowns",...)) end
--print("test test 123")

--local iconHeight = H3DC_Object:GetHeight()


--No, not doing a string indexed table (until I have people who know enUS and whatever client they are to go through and get the instances names as they appear in game.)
--Until then, i am doing a function so instances such as AQ can remain stable on cross country english clients.
local function H3DC_GetInstanceExpansion(dungeonName)
	---If it's a saved regular Vanilla, it's obviously a Cata heroic, this isn't official, it's just in case they ARE.
	if string.find(dungeonName, "Ragefire Chasm") then return 3 ;
	elseif string.find(dungeonName, "Wailing Caverns") then return 3 ;
	elseif string.find(dungeonName, "Blackfathom Deeps") then return 3 ;
	elseif string.find(dungeonName, "Razorfen Kraul") then return 3 ;
	elseif string.find(dungeonName, "Razorfen Downs") then return 3 ;
	elseif string.find(dungeonName, "Zul'Farrak") then return 3 ;
	elseif string.find(dungeonName, "Maraudon") then return 	3 ;
	elseif string.find(dungeonName, "Onyxia's Lair") then return 2 ;
	elseif string.find(dungeonName, "Temple of Ahn'Qiraj") or string.find(dungeonName, "Ahn'Qiraj Temple") then return 0 ;
	elseif string.find(dungeonName, "Ruins of Ahn'Qiraj") or string.find(dungeonName, "Ahn'Qiraj Ruins") then return 0 ;
	elseif string.find(dungeonName, "The Black Morass") then return 1 ;
	elseif string.find(dungeonName, "Hyjal Summit") then return 	1 ;
	elseif string.find(dungeonName, "Old Hillsbrad Foothills") then return 1 ;
	elseif string.find(dungeonName, "Blackrock Depths") then return 3 ;
	elseif string.find(dungeonName, "Blackrock Spire") then return 3 ;
	elseif string.find(dungeonName, "Blackwing Lair") then return 0 ;
	elseif string.find(dungeonName, "Gnomeregan") then return 3 ;
	elseif string.find(dungeonName, "Molten Core") then return 	0 ;
	elseif string.find(dungeonName, "Scholomance") then return 3 ;
	elseif string.find(dungeonName, "Shadowfang Keep") then return 3 ;
	elseif string.find(dungeonName, "Stratholme") then return 3 ;
	elseif string.find(dungeonName, "The Deadmines") then return 3 ;
	elseif string.find(dungeonName, "The Stockade") then return 3 ;
	elseif string.find(dungeonName, "Sunken Temple") then return 3 ;
	elseif string.find(dungeonName, "Uldaman") then return 3 ;
	elseif string.find(dungeonName, "Zul'Gurub") then return 0 ;
	elseif string.find(dungeonName, "Naxxramas") then return 2 ;
	elseif string.find(dungeonName, "Karazhan") then return 	1 ;
	elseif string.find(dungeonName, "Zul'Aman") then return 1 ;
	elseif string.find(dungeonName, "Magister's Terrace") or string.find(dungeonName, "Magisters' Terrace") then return 1 ;
	elseif string.find(dungeonName, "Sunwell Plateau") then return 1 ;
	elseif string.find(dungeonName, "The Blood Furnace") then return 1 ;
	elseif string.find(dungeonName, "The Shattered Halls") then return 1 ;
	elseif string.find(dungeonName, "Hellfire Ramparts") then return 1 ;
	elseif string.find(dungeonName, "Magtheridon's Lair") then return 1 ;
	elseif string.find(dungeonName, "The Slave Pens") then return 1 ;
	elseif string.find(dungeonName, "The Underbog") then return 1 ;
	elseif string.find(dungeonName, "The Steamvault") then return 1 ;
	elseif string.find(dungeonName, "Serpentshrine Cavern") then return 1 ;
	elseif string.find(dungeonName, "Mana-Tombs") then return 1 ;
	elseif string.find(dungeonName, "Auchenai Crypts") then return 1 ;
	elseif string.find(dungeonName, "Sethekk Halls") then return 1 ;
	elseif string.find(dungeonName, "Shadow Labyrinth") then return 1 ;
	elseif string.find(dungeonName, "The Botanica") then return 1 ;
	elseif string.find(dungeonName, "The Arcatraz") then return 1 ;
	elseif string.find(dungeonName, "The Mechanar") then return 	1 ;
	elseif string.find(dungeonName, "The Eye") then return 1 ;
	elseif string.find(dungeonName, "Gruul's Lair") then return 	1 ;
	elseif string.find(dungeonName, "Black Temple") then return 1 ;
	elseif string.find(dungeonName, "Azjol-Nerub") then return 2 ;
	elseif string.find(dungeonName, "The Culling of Stratholme") then return 2 ;
	elseif string.find(dungeonName, "Drak'Tharon Keep") then return 2 ;
	elseif string.find(dungeonName, "Gundrak") then return 2 ;
	elseif string.find(dungeonName, "Halls of Stone") then return 2 ;
	elseif string.find(dungeonName, "Halls of Lightning") then return 2 ;
	elseif string.find(dungeonName, "The Obsidian Sanctum") then return 2 ;
	elseif string.find(dungeonName, "The Ruby Sanctum") then return 2 ; -- so it doesn't break on patch day for people who dont want to update every week
	elseif string.find(dungeonName, "Utgarde Keep") then return 2 ;
	elseif string.find(dungeonName, "Utgarde Pinnacle") then return 2 ;
	elseif string.find(dungeonName, "The Nexus") then return 2 ;
	elseif string.find(dungeonName, "The Eye of Eternity") then return 2 ;
	elseif string.find(dungeonName, "Ahn'kahet: The Old Kingdom") then return 2 ;
	elseif string.find(dungeonName, "Violet Hold") then return 2 ;
	elseif string.find(dungeonName, "The Oculus") then return 2 ;
	elseif string.find(dungeonName, "Ulduar") then return 2 ;
	elseif string.find(dungeonName, "Vault of Archavon") then return 2 ;
	elseif string.find(dungeonName, "Trial of the Crusader") then return 2 ;
	elseif string.find(dungeonName, "Trial of the Champion") then return 2 ;
	elseif string.find(dungeonName, "The Forge of Souls") then return 2 ;
	elseif string.find(dungeonName, "Pit of Saron") then return 2 ;
	elseif string.find(dungeonName, "Halls of Reflection") then return 2 ;
	elseif string.find(dungeonName, "Icecrown Citadel") then return 2 ;
	else return 0 end;

end

-------------------
 --- Functions ---
-------------------

-- This is a very useful code snippet I found on WoWWiki's, you guessed it,
-- code snippet section that takes a decimal percent and several rgb values and creates a color.
local rcg,gcg,bcg,r1cg,g1cg,b1cg,r2cg,g2cg,b2cg --color gradient locals, so our local globals with the same names don't get screwed up.
local num, segment, relperc
local function ColorGradient(perc, ...)
if perc then
	if perc >= 1 then
		rcg, gcg, bcg = select(select('#', ...) - 2, ...)
		return rcg, gcg, bcg
	elseif perc <= 0 then
		rcg, gcg, bcg = ...
		return rcg, gcg, bcg
	end

	num = select('#', ...) / 3

	segment, relperc = math.modf(perc*(num-1))
	r1cg, g1cg, b1cg, r2cg, g2cg, b2cg = select((segment*3)+1, ...)

	return r1cg + (r2cg-r1cg)*relperc, g1cg + (g2cg-g1cg)*relperc, b1cg + (b2cg-b1cg)*relperc
end
return 0, 0, 0
end

--------------
 --- Hooks ---
--------------
--When our broker module is enabled--
function Broker_H3DC:OnEnable()
	-- Define default settings --
	self.db = LibStub("AceDB-3.0"):New("Broker_H3DungeonCooldownsDB", { profile = {
		iconOnly = false, 		-- Whether or not it's icon only for broker addon displays that don't have that already built-in to every plugin
		tooltipFont = GameTooltipText:GetFont(), 	-- Get the actual font name
		tooltipFontV = "Friz Quadrata TT", 	-- "LibQTip allows for font changes, and I like a particular font more then the default one"
		textSize = 12, 			-- Text for all the instances lines
		headerSize = 15, 		-- Text for Addon Name
		nameSize = 14,			-- Name size bioches.
		tiphintSize = 10, 		-- Tooltip help at the bottom of the.. Tooltip.. >.>
		subheaderSize = 13, 	-- Size of expansion headers.
		fontScale = 1,			-- Scale of the font sizes.
		tooltipHeight = 750,	-- LibQTip has a tooltip height limiter, I'm going to set it to 750 by default.
		defaultNameCol = {130/200,200/200,200/200,1},

		classCol_DEATHKNIGHT = 	{196/255, 	30/255, 	59/255,		1},
		classCol_DRUID = 		{255/255, 	125/255, 	10/255,		1},
		classCol_HUNTER = 		{171/255, 	212/255, 	115/255,	1},
		classCol_MAGE = 		{105/255, 	204/255, 	240/255,	1},
		classCol_PALADIN = 		{255/255, 	150/255, 	196/255,	1},
		classCol_PRIEST = 		{1,			1,			1,			1},
		classCol_ROGUE = 		{255/255, 	245/255, 	105/255,	1},
		classCol_SHAMAN = 		{36/255, 	89/255, 	255/255,	1},
		classCol_WARLOCK = 		{148/255, 	130/255, 	201/255,	1},
		classCol_WARRIOR = 		{199/255, 	156/255, 	110/255,	1},
		dunNameCol = {130/200,255/255,130/200,1},
		dunDiffCol = {130/200,200/200,200/200,1},
		dunUnlockCol = {200/255,200/255,200/255,1},
		dunLoTimeCol = {0/200,200/200,0/200,1},
		dunMeTimeCol = {200/200,200/200,0/200,1},
		dunHiTimeCol = {200/200,0/200,0/200,1},
		dunDunIDCol = {130/200,130/200,130/200,1},
		dunDateCol = {200/200,200/200,130/200,1},
		separatorCol = {1,1,1,1},

		classColors = true,
		AllToons = true, -- Show data for every toon on the server

		showID = false,
		showDate = false,

		separatorSize = 2,

		expansionHeaders = "WHITESPACE",

		showVanilla = true,
		showBurningCrusade = true,
		showWrathoftheLichKing = true,
		showCataclysm = false, -- Doing it now so it won't be as much of a pain in the arse when Cataclysm DOES come out.
		--I'm assuming all non-raid vanilla instances are cataclysm since they don't have a heroic mode yet and can't be saved :P
		iconScale = 2,
		showUnlocked = true,
		showLFDIcon = false,
	}}, "Default")

	--Define database related variables for first-time users.
	db = self.db.profile
	db.SMTextures = {}
	db.SMFonts = {}
	db.REVISION = "017"

	--Define variables that might or might not be defined depending on
	--if you are a first time user overall or on current character/server etc.
	if not db.CharacterTbl then db.CharacterTbl = {} end
	if not db.CharacterTbl[GetRealmName()] then db.CharacterTbl[GetRealmName()] = {} end
	if not db.RealmTbl then db.RealmTbl = {} end
	if not db.AccountCDs then db.AccountCDs = {} end
	if not db.AccountCDs[GetRealmName()] then db.AccountCDs[GetRealmName()] = {} end
	if not db.AccountCDs[GetRealmName()][GetUnitName("player")] then db.AccountCDs[GetRealmName()][GetUnitName("player")] = {} end
	if not db.AccountCDs[GetRealmName()][GetUnitName("player")].vanilla then db.AccountCDs[GetRealmName()][GetUnitName("player")].vanilla = {} db.AccountCDs[GetRealmName()][GetUnitName("player")].bc = {} db.AccountCDs[GetRealmName()][GetUnitName("player")].wotlk = {} db.AccountCDs[GetRealmName()][GetUnitName("player")].cataclysm = {} end
	if not db.ToonHasCD then db.ToonHasCD = {} end

	if not db.ToonHasCD.vanilla then db.ToonHasCD.vanilla = {} end
	if not db.ToonHasCD.bc then db.ToonHasCD.bc = {} end
	if not db.ToonHasCD.wotlk then db.ToonHasCD.wotlk = {} end
	if not db.ToonHasCD.cataclysm then db.ToonHasCD.cataclysm = {} end

	if not db.CharacterClasses then db.CharacterClasses = {} end
	if not db.CharacterClasses[GetRealmName()] then db.CharacterClasses[GetRealmName()] = {} end
	local playerClass, englishClass = UnitClass("player")
	db.CharacterClasses[GetRealmName()][GetUnitName("player")] = englishClass

	-- The reason these functions are global instead of local is because they rely on the database,
	-- which is loaded inside this event and isn't loaded yet the beginning of the code.

	---Returns a class color based on the given name and the current database values for the class colors---
	function H3DC_GetClassColor(classVAR)
	if db.classColors then
		if classVAR == "DEATHKNIGHT" then return {db.classCol_DEATHKNIGHT[1]*255, db.classCol_DEATHKNIGHT[2]*255, db.classCol_DEATHKNIGHT[3]*255}
		elseif classVAR == "DRUID" then return {db.classCol_DRUID[1]*255, db.classCol_DRUID[2]*255, db.classCol_DRUID[3]*255}
		elseif classVAR == "HUNTER" then return {db.classCol_HUNTER[1]*255, db.classCol_HUNTER[2]*255, db.classCol_HUNTER[3]*255}
		elseif classVAR == "MAGE" then return {db.classCol_MAGE[1]*255, db.classCol_MAGE[2]*255, db.classCol_MAGE[3]*255}
		elseif classVAR == "PALADIN" then return {db.classCol_PALADIN[1]*255, db.classCol_PALADIN[2]*255, db.classCol_PALADIN[3]*255}
		elseif classVAR == "PRIEST" then return {db.classCol_PRIEST[1]*255, db.classCol_PRIEST[2]*255, db.classCol_PRIEST[3]*255}
		elseif classVAR == "ROGUE" then return {db.classCol_ROGUE[1]*255, db.classCol_ROGUE[2]*255, db.classCol_ROGUE[3]*255}
		elseif classVAR == "SHAMAN" then return {db.classCol_SHAMAN[1]*255, db.classCol_SHAMAN[2]*255, db.classCol_SHAMAN[3]*255}
		elseif classVAR == "WARLOCK" then return {db.classCol_WARLOCK[1]*255, db.classCol_WARLOCK[2]*255, db.classCol_WARLOCK[3]*255}
		elseif classVAR == "WARRIOR" then return {db.classCol_WARRIOR[1]*255, db.classCol_WARRIOR[2]*255, db.classCol_WARRIOR[3]*255}
		else return {125, 125, 125} end
	else
		return {db.defaultNameCol[1]*255,db.defaultNameCol[2]*255,db.defaultNameCol[3]*255}
	end
	end

	-----------------------------------------------
	-- Code snippet from Orionshock.
	--  I modified it to suit my needs.
	MiniMapLFGFrame:SetScript("OnShow", function(self)
		if GetLFGMode() then
			if not db.showLFDIcon then
				self:Hide()
			end
		else
			self:Hide()
		end
	end)
	MiniMapLFGFrame:SetScript("OnHide", function(self)
		if GetLFGMode() then
			if db.showLFDIcon then
				self:Show()
			end
		else
			self:Hide()
		end
	end)
	-----------------------------------------------



	exists = false
	for k, v in pairs(db.CharacterTbl[GetRealmName()]) do
	if v == GetUnitName("player") then exists = true end
	end
	if exists == false then
	db.CharacterTbl[GetRealmName()][#(db.CharacterTbl[GetRealmName()])+1] = GetUnitName("player")
	end
	exists = false
	for k,v in pairs(db.RealmTbl) do
	if v == GetRealmName() then exists = true end
	end
	if exists == false then
	db.RealmTbl[#(db.RealmTbl)+1] = GetRealmName()
	end



	-------Update cooldowns >.>-------
	function H3DC_UpdateCooldowns()
	-- This is where we check for cooldowns, update them, etc.
	--------------------------------------------------------------------------------------------------------------
	--------------------------------------------CURRENT DATA FORMATING--------------------------------------------
	--====--{name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName}--====--
	---------1-----2---3------4-----------5-------6---------7----------8-------9-----------10---------------------
	--------------------------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------------------------
		db.AccountCDs[GetRealmName()][GetUnitName("player")].vanilla	 = {} --Clear the Vanilla table
		db.AccountCDs[GetRealmName()][GetUnitName("player")].bc			 = {} --Clear the BC table
		db.AccountCDs[GetRealmName()][GetUnitName("player")].wotlk		 = {} --Clear the WotLK table
		db.AccountCDs[GetRealmName()][GetUnitName("player")].cataclysm	 = {} --Clear the Cataclysm table
		-- For index = 1, amount of saved instances do Loop

		-- Reviewing the data again. Possibility of updating in the minute of lock resets.
		db.ToonHasCD[GetUnitName("player") .. " - " .. GetRealmName()] = false
		db.ToonHasCD.vanilla[GetUnitName("player") .. " - " .. GetRealmName()] = false
		db.ToonHasCD.bc[GetUnitName("player") .. " - " .. GetRealmName()] = false
		db.ToonHasCD.wotlk[GetUnitName("player") .. " - " .. GetRealmName()] = false
		db.ToonHasCD.cataclysm[GetUnitName("player") .. " - " .. GetRealmName()] = false

		for k=1, GetNumSavedInstances() do
			name, id, reset, difficulty, locked, extended, _, isRaid, maxPlayers, difficultyName = GetSavedInstanceInfo(k)
			if locked then db.ToonHasCD[GetUnitName("player") .. " - " .. GetRealmName()] = true end
			dunExpansion = H3DC_GetInstanceExpansion(name)
			if dunExpansion == 0 then --VANILLA
				db.AccountCDs[GetRealmName()][GetUnitName("player")].vanilla[#(db.AccountCDs[GetRealmName()][GetUnitName("player")].vanilla)+1] = {name, id, reset, difficulty, locked, extended, time(), isRaid, maxPlayers, difficultyName,k}
				if locked then db.ToonHasCD.vanilla[GetUnitName("player") .. " - " .. GetRealmName()] = true end
			elseif dunExpansion == 1 then --BC
				db.AccountCDs[GetRealmName()][GetUnitName("player")].bc[#(db.AccountCDs[GetRealmName()][GetUnitName("player")].bc)+1] = {name, id, reset, difficulty, locked, extended, time(), isRaid, maxPlayers, difficultyName,k}
				if locked then db.ToonHasCD.bc[GetUnitName("player") .. " - " .. GetRealmName()] = true end
			elseif dunExpansion == 2 then --WOTLK
				db.AccountCDs[GetRealmName()][GetUnitName("player")].wotlk[#(db.AccountCDs[GetRealmName()][GetUnitName("player")].wotlk)+1] = {name, id, reset, difficulty, locked, extended, time(), isRaid, maxPlayers, difficultyName,k}
				if locked then db.ToonHasCD.wotlk[GetUnitName("player") .. " - " .. GetRealmName()] = true end
			elseif dunExpansion == 3 then --CATACLYSM
				db.AccountCDs[GetRealmName()][GetUnitName("player")].cataclysm[#(db.AccountCDs[GetRealmName()][GetUnitName("player")].cataclysm)+1] = {name, id, reset, difficulty, locked, extended, time(), isRaid, maxPlayers, difficultyName,k}
				if locked then db.ToonHasCD.cataclysm[GetUnitName("player") .. " - " .. GetRealmName()] = true end
			end

			---Sort Vanilla
			table.sort(db.AccountCDs[GetRealmName()][GetUnitName("player")].vanilla, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

			---Sort Burning Crusade
			table.sort(db.AccountCDs[GetRealmName()][GetUnitName("player")].bc, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

			---Sort Wrath of The Lich King
			table.sort(db.AccountCDs[GetRealmName()][GetUnitName("player")].wotlk, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

			---Sort Cataclysm
			table.sort(db.AccountCDs[GetRealmName()][GetUnitName("player")].cataclysm, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

		end
		--print("-----") -- Debug
		--print("-----") -- Debug
		for _, v in pairs(db.CharacterTbl[GetRealmName()]) do
			--print(v)
			-- Reviewing the data again. Possibility of updating in the minute of lock resets.
			db.ToonHasCD[v .. " - " .. GetRealmName()] = false
			db.ToonHasCD.vanilla[v .. " - " .. GetRealmName()] = false
			db.ToonHasCD.bc[v .. " - " .. GetRealmName()] = false
			db.ToonHasCD.wotlk[v .. " - " .. GetRealmName()] = false
			db.ToonHasCD.cataclysm[v .. " - " .. GetRealmName()] = false

			---VANILLA
			for i, k in pairs(db.AccountCDs[GetRealmName()][v].vanilla) do
				name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
				if locked then db.ToonHasCD[v .. " - " .. GetRealmName()] = true db.ToonHasCD.vanilla[v .. " - " .. GetRealmName()] = true end
				reset, dateSaved = reset - (time() - dateSaved), time()
				if reset < 0 and locked then
					locked = false
				end
				db.AccountCDs[GetRealmName()][v].vanilla[i] = {name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index}
			end

			---BURNING CRUSADE
			for i, k in pairs(db.AccountCDs[GetRealmName()][v].bc) do
				name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
				if locked then db.ToonHasCD[v .. " - " .. GetRealmName()] = true db.ToonHasCD.bc[v .. " - " .. GetRealmName()] = true end
				reset, dateSaved = reset - (time() - dateSaved), time()
				if reset < 0 and locked then
					locked = false
				end
				db.AccountCDs[GetRealmName()][v].bc[i] = {name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index}
			end

			---WRATH OF THE LICH KING
			for i, k in pairs(db.AccountCDs[GetRealmName()][v].wotlk) do
				name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
				if locked then db.ToonHasCD[v .. " - " .. GetRealmName()] = true db.ToonHasCD.wotlk[v .. " - " .. GetRealmName()] = true end
				reset, dateSaved = reset - (time() - dateSaved), time()
				if reset < 0 and locked then
					locked = false
				end
				db.AccountCDs[GetRealmName()][v].wotlk[i] = {name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index}
			end

			---CATACLYSM
			for i, k in pairs(db.AccountCDs[GetRealmName()][v].cataclysm) do
				name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
				if locked then db.ToonHasCD[v .. " - " .. GetRealmName()] = true db.ToonHasCD.cataclysm[v .. " - " .. GetRealmName()] = true end
				reset, dateSaved = reset - (time() - dateSaved), time()
				if reset < 0 and locked then
					locked = false
				end
				db.AccountCDs[GetRealmName()][v].cataclysm[i] = {name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index}
			end




			---Sort Vanilla
			table.sort(db.AccountCDs[GetRealmName()][v].vanilla, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

			---Sort Burning Crusade
			table.sort(db.AccountCDs[GetRealmName()][v].bc, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

			---Sort Wrath of The Lich King
			table.sort(db.AccountCDs[GetRealmName()][v].wotlk, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

			---Sort Cataclysm
			table.sort(db.AccountCDs[GetRealmName()][v].cataclysm, function(a,b)
			if string.lower(a[1]) == string.lower(b[1]) then
				return string.lower(a[4]) < string.lower(b[4])
			else
				return string.lower(a[1]) < string.lower(b[1])
			end
			end)

		end
		--print("-----") -- Debug
		--print("-----") -- Debug

	end


-- This adds a seperator via whitespace or expansion name for the cooldown sections --
	function H3DC_AddExpansionHeader(expansionName)
		if not tooltip then return end
		if db.expansionHeaders == "NONE" then return end
		if db.expansionHeaders == "WHITESPACE" then
			placeHolder = tooltip:AddLine(" ")
			tooltip:SetCell(placeHolder, 1, " ", whitespaceFont, "CENTER", tooltip:GetColumnCount())
		end
		if db.expansionHeaders == "NAME" then
			placeHolder = tooltip:AddLine(" ")
			tooltip:SetCell(placeHolder, 1, expansionName, textFont, "CENTER", tooltip:GetColumnCount())
		end
	end

-- This adds a cooldown information line based on the information passed through the function --
	function H3DC_Addline(name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index, toonName, toonServer)
		if not tooltip then return end
		roundedReset = reset - (reset % 1800) -- round to the nearest 30 minutes :P
		dateRounded = (time())  -  (time() % 1800) + 1800
		if isRaid then
			r,g,b = ColorGradient(reset / 604800, db.dunLoTimeCol[1],db.dunLoTimeCol[2],db.dunLoTimeCol[3], db.dunMeTimeCol[1],db.dunMeTimeCol[2],db.dunMeTimeCol[3], db.dunHiTimeCol[1],db.dunHiTimeCol[2],db.dunHiTimeCol[3])
		else
			r,g,b = ColorGradient(reset / 86400, db.dunLoTimeCol[1],db.dunLoTimeCol[2],db.dunLoTimeCol[3], db.dunMeTimeCol[1],db.dunMeTimeCol[2],db.dunMeTimeCol[3], db.dunHiTimeCol[1],db.dunHiTimeCol[2],db.dunHiTimeCol[3])
		end
		local dateHours = tonumber(date("%H",dateRounded+roundedReset))
		if dateHours > 12 then
			dateHours = dateHours - 12
			dateTwelveHour = "PM"
		else
			dateTwelveHour = "AM"
		end
		local dateString = string.format("%s:%s %s %s/%s/%s",tostring(dateHours), tostring(date("%M",dateRounded+roundedReset)), dateTwelveHour, tostring(date("%m",dateRounded+roundedReset)), tostring(date("%d",dateRounded+roundedReset)), tostring(date("%Y",dateRounded+roundedReset)))
		if locked then
		id = "[" .. id .. "]"
		reset = SecondsToTime(reset)
		else
		dateString = ""
		id = ""
		reset = "Unlocked!"
		r,g,b = db.dunUnlockCol[1], db.dunUnlockCol[2], db.dunUnlockCol[3]
		end
		if db.showID and db.showDate then
			tooltip:AddLine(
				string.format("|cff%02x%02x%02x%s",db.dunNameCol[1]*255,db.dunNameCol[2]*255,db.dunNameCol[3]*255,name),
				string.format("|cff%02x%02x%02x%s",db.dunDiffCol[1]*255,db.dunDiffCol[2]*255,db.dunDiffCol[3]*255,difficultyName),
				string.format("|cff%02x%02x%02x%s",r*255,g*255,b*255,reset),
				string.format("|cff%02x%02x%02x%s",db.dunDunIDCol[1]*255,db.dunDunIDCol[2]*255,db.dunDunIDCol[3]*255,id),
				string.format("|cff%02x%02x%02x%s",db.dunDateCol[1]*255,db.dunDateCol[2]*255,db.dunDateCol[3]*255,dateString)
			)
		elseif db.showID and (not db.showDate) then
			tooltip:AddLine(
				string.format("|cff%02x%02x%02x%s",db.dunNameCol[1]*255,db.dunNameCol[2]*255,db.dunNameCol[3]*255,name),
				string.format("|cff%02x%02x%02x%s",db.dunDiffCol[1]*255,db.dunDiffCol[2]*255,db.dunDiffCol[3]*255,difficultyName),
				string.format("|cff%02x%02x%02x%s",r*255,g*255,b*255,reset),
				string.format("|cff%02x%02x%02x%s",db.dunDunIDCol[1]*255,db.dunDunIDCol[2]*255,db.dunDunIDCol[3]*255,id)
			)
		elseif (not db.showID) and db.showDate then
			tooltip:AddLine(
				string.format("|cff%02x%02x%02x%s",db.dunNameCol[1]*255,db.dunNameCol[2]*255,db.dunNameCol[3]*255,name),
				string.format("|cff%02x%02x%02x%s",db.dunDiffCol[1]*255,db.dunDiffCol[2]*255,db.dunDiffCol[3]*255,difficultyName),
				string.format("|cff%02x%02x%02x%s",r*255,g*255,b*255,reset),
				string.format("|cff%02x%02x%02x%s",db.dunDateCol[1]*255,db.dunDateCol[2]*255,db.dunDateCol[3]*255,dateString)
			)
		elseif (not db.showID) and (not db.showDate) then
			tooltip:AddLine(
				string.format("|cff%02x%02x%02x%s",db.dunNameCol[1]*255,db.dunNameCol[2]*255,db.dunNameCol[3]*255,name),
				string.format("|cff%02x%02x%02x%s",db.dunDiffCol[1]*255,db.dunDiffCol[2]*255,db.dunDiffCol[3]*255,difficultyName),
				string.format("|cff%02x%02x%02x%s",r*255,g*255,b*255,reset)
			)
		end
		--print(toonName .. toonServer)
		if locked then
			tooltip:SetLineScript(tooltip:GetLineCount(), "OnMouseDown", function()
			if IsShiftKeyDown() and toonName == GetUnitName("player") and toonServer == GetRealmName() then
				if extended then
					SetSavedInstanceExtend(index, false)
				else
					SetSavedInstanceExtend(index, true)
				end
						RequestRaidInfo()
						pendingRequestInfo = true
			else
				--ChatFrame1EditBox:Show() ChatFrame1EditBox:Insert("Hello, darr!")
				ChatFrame1EditBox:Show() ChatFrame1EditBox:Insert(string.format("<%s> %s (%s) - ID: %s - %s (%s)",toonName, name, difficultyName, id, string.gsub(string.gsub(string.gsub(string.gsub(string.gsub(string.gsub(reset, "|4Hr", ""), "|4Day", ""), "|4Min", ""), "|4Sec", ""), ";", ""), ":", ""), dateString))
				--string.format("%s (%s) - ID: %s - %s (%s)",name, difficultyName, id, reset, dateString)
			end
			end)
		end
	end



-- This takes all the data from a player - assuming it exists - and creates a list of lockouts --
	function H3DC_SetupCooldowns(toonName,toonServer)
		if not tooltip then return end
		if db.ToonHasCD[toonName .. " - " .. toonServer] then
		-- I have to use locals here because the line scripts don't take what the variable currently is, it takes what it is when the line script is run.
			tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
			placeHolder = tooltip:AddLine(" ")
			r,g,b = unpack(H3DC_GetClassColor(db.CharacterClasses[toonServer][toonName]))
			tooltip:SetCell(placeHolder, 1, string.format("|cff%02x%02x%02x%s",r,g,b,toonName), nameFont, "CENTER", tooltip:GetColumnCount())
			LineCount = tooltip:GetLineCount()
			---Cataclysm
			if db.ToonHasCD.cataclysm[toonName .. " - " .. toonServer] and db.showCataclysm then
				if (not (LineCount == tooltip:GetLineCount())) or (not (db.expansionHeaders == "WHITESPACE")) then
					H3DC_AddExpansionHeader("Cataclysm")
				end
				for i, k in pairs(db.AccountCDs[toonServer][toonName].cataclysm) do
					local name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
					if (locked or (locked == false and db.showUnlocked)) then
					H3DC_Addline(name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index, toonName, toonServer)
					end
				end
			end

			---Wotlk
			if db.ToonHasCD.wotlk[toonName .. " - " .. toonServer] and db.showWrathoftheLichKing then
				if (not (LineCount == tooltip:GetLineCount())) or (not (db.expansionHeaders == "WHITESPACE")) then
					H3DC_AddExpansionHeader("Wrath of the Lich King")
				end
				for i, k in pairs(db.AccountCDs[toonServer][toonName].wotlk) do
					local name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
					if (locked or (locked == false and db.showUnlocked)) then
					H3DC_Addline(name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index, toonName, toonServer)
					end
				end
			end

			---BC
			if db.ToonHasCD.bc[toonName .. " - " .. toonServer] and db.showBurningCrusade then
				if (not (LineCount == tooltip:GetLineCount())) or (not (db.expansionHeaders == "WHITESPACE")) then
					H3DC_AddExpansionHeader("Burning Crusade")
				end
				for i, k in pairs(db.AccountCDs[toonServer][toonName].bc) do
					local name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
					if (locked or (locked == false and db.showUnlocked)) and db.showBurningCrusade then
					H3DC_Addline(name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index, toonName, toonServer)
					end
				end
			end

			---VANILLA
			if db.ToonHasCD.vanilla[toonName .. " - " .. toonServer] and db.showVanilla then
				if (not (LineCount == tooltip:GetLineCount())) or (not (db.expansionHeaders == "WHITESPACE")) then
					H3DC_AddExpansionHeader("Vanilla")
				end
				for i, k in pairs(db.AccountCDs[toonServer][toonName].vanilla) do
					local name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index = unpack(k)
					if (locked or (locked == false and db.showUnlocked)) and db.showVanilla then
					H3DC_Addline(name, id, reset, difficulty, locked, extended, dateSaved, isRaid, maxPlayers, difficultyName, index, toonName, toonServer)
					end
				end
			end

			if LineCount == tooltip:GetLineCount() then
				placeHolder = tooltip:AddLine(" ")
				tooltip:SetCell(placeHolder, 1, "No locked dungeons.", nameFont, "CENTER", tooltip:GetColumnCount())
			end
			end
	end


	--Font and statusbar textures--
	for k, v in pairs(LibStub:GetLibrary("LibSharedMedia-3.0"):List("statusbar")) do
		db.SMTextures[v] = LibStub:GetLibrary("LibSharedMedia-3.0"):Fetch("statusbar", v, false)
	end
	for k, v in pairs(LibStub:GetLibrary("LibSharedMedia-3.0"):List("font")) do
		db.SMFonts[v] = LibStub:GetLibrary("LibSharedMedia-3.0"):Fetch("font", v, false)
	end


-- The options
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_H3DungeonCooldowns", {
		name = "Broker H3 DungeonCooldowns", type = "group",
		get = function(key) return db[key.arg] end,
		set = function(key, value) db[key.arg] = value end,
		args = {
			header1 = { name = "Basic Options", type = "header", order = 1 },
			iconOnly = {
				name = "Icon Only",
				type = "toggle", order = 2, arg = "iconOnly",
				get = function(key) return db[key.arg] end,
				set = function(key, value) db[key.arg] = value
					if value then
					H3DC_Object.text = ""
					else
					H3DC_Object.text = "H3 DungeonCooldowns"
					end
				end
			},
			showUnlocked = {
				name = "Show Unlocked",
				type = "toggle", order = 3, arg = "showUnlocked",
			},

			showDate = {
				name = "Show Date",
				type = "toggle", order = 4, arg = "showDate",
			},

			showID = {
				name = "Show ID",
				type = "toggle", order = 5, arg = "showID",
			},

			iconOnly = {
				name = "LFD Minimap Icon",
				type = "toggle", order = 6, arg = "showLFDIcon",
				get = function(key) return db[key.arg] end,
				set = function(key, value) db[key.arg] = value
							if GetLFGMode() then
								if db.showLFDIcon then
									MiniMapLFGFrame:Show()
								else
									MiniMapLFGFrame:Hide()
								end
							else
								MiniMapLFGFrame:Hide()
							end
				end
			},
			showVanilla = {
				name = "Show Vanilla", width = 'full',
				type = "toggle", order = 7, arg = "showVanilla",
			},

			showBurningCrusade = {
				name = "Show Burning Crusade", width = 'full',
				type = "toggle", order = 8, arg = "showBurningCrusade",
			},

			showWrathoftheLichKing = {
				name = "Show Wrath of the Lich King", width = 'full',
				type = "toggle", order = 9, arg = "showWrathoftheLichKing",
			},

			showCataclysm = {
				name = "Show Cataclysm (NYI)", width = 'full',
				type = "toggle", order = 10, arg = "showCataclysm",
			},

			AllToons = {
				name = "All Characters (on server)",
				type = "toggle", order = 11, arg = "AllToons", width = 'full',
			},

			expansionHeaders = {
				name = "Expansion Headers",
				type = 'select', order = 12, arg = "expansionHeaders", width = 'full',
				values = expHeaderOptions,
				get = function(key) return db[key.arg] end,
				set = function(key, value) db[key.arg] = value end
			},

			header2 = { name = "Font Options", type = "header", order = 31 },
			tooltipFont = {
				name = "Tooltip Font",
				type = 'select', dialogControl = 'LSM30_Font', order = 32, arg = "tooltipFontV", width = 'full',
				values = db.SMFonts,
				get = function(key) return db[key.arg] end,
				set = function(key, value) db[key.arg] = value   db.tooltipFont = db.SMFonts[value] end
			},
			tooltipHeight = {
				name = "Tooltip Height (Max)",
				type = "range", order = 33,  min = 100, max = 2000, bigStep = 10, arg = "tooltipHeight", width = 'full',
				},
			fontScale = {
				name = "Font Scale",
				type = "range", order = 34,  min = 0.5, max = 2, bigStep = 0.05, arg = "fontScale", width = 'full',
				},
			textSize = {
				name = "Text Size",
				type = "range", order = 35,  min = 5, max = 30, bigStep = 1, arg = "textSize",
				},
			headerSize = {
				name = "Header Size",
				type = "range", order = 36,  min = 5, max = 30, bigStep = 1, arg = "headerSize",
				},
			nameSize = {
				name = "Name Size",
				type = "range", order = 37,  min = 5, max = 30, bigStep = 1, arg = "nameSize",
				},
			tiphintSize = {
				name = "Hint Size",
				type = "range", order = 38,  min = 5, max = 30, bigStep = 1, arg = "tiphintSize",
				},
			iconScale = {
				name = "Icon Scale",
				type = "range", order = 39,  min = 0.5, max = 4, bigStep = 0.1, arg = "iconScale",
				},
			separatorSize = {
				name = "Separator Height",
				type = "range", order = 40,  min = 1, max = 10, bigStep = 1, arg = "separatorSize",
				},
			resetTextOptions = {
				name = "Reset Text Settings",
				type = "execute", order = 41, func = function()
						db.textSize = 12
						db.headerSize = 15
						db.nameSize = 14
						db.subheaderSize = 13
						db.tiphintSize = 10
						db.fontScale = 1
						db.separatorSize = 2
						db.iconScale = 2
						end,
				},

			header3 = { name = "Class Color Options", type = "header", order = 50 },
			classColors = {
				name = "Color Name by Class Colors",
				type = "toggle", order = 51, arg = "classColors", width = 'full',
			},
			defaultNameCol = {
				name = "Default Name Color",
 				type = "color", order = 52, hasAlpha = false, --width = 'double',
                   get = function(info) return unpack(db.defaultNameCol) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.defaultNameCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetDefaultNameCol = {
				name = "Reset", --width = 'double',
				type = "execute", order = 53, func = function()
						db.defaultNameCol = {130/200,200/200,200/200,1}
				end,
				},



			classCol_DEATHKNIGHT = {
				name = "Death Knight Color",
 				type = "color", order = 54, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_DEATHKNIGHT) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_DEATHKNIGHT
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_DEATHKNIGHT = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 55, func = function()
						db.classCol_DEATHKNIGHT = {196/255, 30/255, 59/255,	1}
				end,
				},



			classCol_DRUID = {
				name = "Druid Color",
 				type = "color", order = 56, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_DRUID) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_DRUID
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_DRUID = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 57, func = function()

						db.classCol_DRUID = {255/255, 125/255, 10/255, 1}
				end,
				},



			classCol_HUNTER = {
				name = "Hunter Color",
 				type = "color", order = 58, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_HUNTER) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_HUNTER
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_HUNTER = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 59, func = function()

						db.classCol_HUNTER = {171/255, 	212/255, 	115/255,	1}
				end,
				},



			classCol_MAGE = {
				name = "Mage Color",
 				type = "color", order = 60, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_MAGE) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_MAGE
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_MAGE = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 61, func = function()

						db.classCol_MAGE = {105/255, 	204/255, 	240/255,	1}
				end,
				},



			classCol_PALADIN = {
				name = "Paladin Color",
 				type = "color", order = 62, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_PALADIN) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_PALADIN
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_PALADIN = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 63, func = function()

						db.classCol_PALADIN = {255/255, 	150/255, 	196/255,	1}
				end,
				},



			classCol_PRIEST = {
				name = "Priest Color",
 				type = "color", order = 64, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_PRIEST) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_PRIEST
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_PRIEST = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 65, func = function()

						db.classCol_PRIEST = {1,			1,			1,			1}
				end,
				},



			classCol_ROGUE = {
				name = "Rogue Color",
 				type = "color", order = 66, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_ROGUE) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_ROGUE
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_ROGUE = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 67, func = function()

						db.classCol_ROGUE = {255/255, 	245/255, 	105/255,	1}
				end,
				},



			classCol_SHAMAN = {
				name = "Shaman Color",
 				type = "color", order = 68, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_SHAMAN) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_SHAMAN
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_SHAMAN = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 69, func = function()

						db.classCol_SHAMAN = {36/255, 	89/255, 	255/255,	1}
				end,
				},



			classCol_WARLOCK = {
				name = "Warlock Color",
 				type = "color", order = 70, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_WARLOCK) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_WARLOCK
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_WARLOCK = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 71, func = function()

						db.classCol_WARLOCK = {148/255, 	130/255, 	201/255,	1}
				end,
				},



			classCol_WARRIOR = {
				name = "Warrior Color",
 				type = "color", order = 72, hasAlpha = false, -- width = 'halffull',
                   get = function(info) return unpack(db.classCol_WARRIOR) end,
                    set = function(info, r, g, b, a)
                   local tempCol = db.classCol_WARRIOR
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetclassCol_WARRIOR = {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 73, func = function()

						db.classCol_WARRIOR = {199/255, 	156/255, 	110/255,	1}
				end,
				},

			header4 = { name = "Other Color Options", type = "header", order = 94 },


			dunNameCol = {
				name = "Name Color",
 				type = "color", order = 95, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunNameCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunNameCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunNameCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 96, func = function()
						db.dunNameCol = {130/200,255/255,130/200,1}
				end,
				},

			dunDiffCol = {
				name = "Difficulty Color",
 				type = "color", order = 97, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunDiffCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunDiffCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunDiffCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 98, func = function()
						db.dunDiffCol = {130/200,200/200,200/200,1}
				end,
				},

			dunUnlockCol = {
				name = "Unlocked Color",
 				type = "color", order = 99, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunUnlockCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunUnlockCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunUnlockCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 100, func = function()
						db.dunUnlockCol = {200/255,200/255,200/255,1}
				end,
				},

			dunLoTimeCol = {
				name = "'Low' Time",
 				type = "color", order = 101, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunLoTimeCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunLoTimeCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunLoTimeCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 102, func = function()
						db.dunLoTimeCol = {0/200,200/200,0/200,1}
				end,
				},

			dunMeTimeCol = {
				name = "'Medium' Time",
 				type = "color", order = 103, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunMeTimeCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunMeTimeCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunMeTimeCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 104, func = function()
						db.dunMeTimeCol = {200/200,200/200,0/200,1}
				end,
				},

			dunHiTimeCol = {
				name = "'High' Time",
 				type = "color", order = 105, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunHiTimeCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunHiTimeCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunHiTimeCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 106, func = function()
						db.dunHiTimeCol = {200/200,0/200,0/200,1}
				end,
				},

			dunDunIDCol = {
				name = "Dungeon ID",
 				type = "color", order = 107, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunDunIDCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunDunIDCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunDunIDCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 108, func = function()
						db.dunDunIDCol = {130/200,130/200,130/200,1}
				end,
				},

			dunDateCol = {
				name = "Unlock Date",
 				type = "color", order = 109, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.dunDateCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.dunDateCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetdunDateCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 110, func = function()
						db.dunDateCol = {200/200,200/200,130/200,1}
				end,
				},

			separatorCol = {
				name = "Section Separators",
 				type = "color", order = 111, hasAlpha = false, -- width = 'halffull',
					get = function(info) return unpack(db.separatorCol) end,
                    set = function(info, r, g, b, a)
					local tempCol = db.separatorCol
                        tempCol[1], tempCol[2], tempCol[3], tempCol[4] = r, g, b, a
                    end,
			},

			resetseparatorCol= {
				name = "Reset", -- width = 'halffull',
				type = "execute", order = 112, func = function()
						db.separatorCol = {1,1,1,1}
				end,
				},





		},
	})

	--Add to blizzard options for those tho don't want the standalone config for some reason--
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_H3DungeonCooldowns", "Broker H3 DungeonCooldowns")

	--Create our standalone configuration using the config made above.
    LibStub("AceConfigDialog-3.0"):SetDefaultSize("Broker_H3DungeonCooldowns", 400, 600)

	--Create slash commands to open the standalone config
	_G.SlashCmdList["H3DC"] = function() LibStub("AceConfigDialog-3.0"):Open("Broker_H3DungeonCooldowns") end
	_G["SLASH_H3DC1"] = "/brokerh3dc"
	_G["SLASH_H3DC2"] = "/h3dc"
	_G["SLASH_H3DC3"] = "/h3dungeoncooldown"
	_G["SLASH_H3DC4"] = "/h3dungeoncooldowns"

end


-----------------------------------
-------------- EVENTS -------------
-----------------------------------
Broker_H3DC:RegisterEvent('PLAYER_ENTERING_WORLD', function()
	if not pendingRequestInfo then
		pendingRequestInfo = true
		RequestRaidInfo()
	end
end)



Broker_H3DC:RegisterEvent('UPDATE_INSTANCE_INFO', function()
	if pendingRequestInfo then
	pendingRequestInfo = false
	end
	H3DC_UpdateCooldowns()
end)



Broker_H3DC:RegisterEvent('LFG_PROPOSAL_SHOW', function()
	print("A dungeon group has just been found.")
	-- For those who don't have DBM, show them how long they have to accept --
	TOTALTIME = 100
	elapsed = 0
	proposalExists, typeID, id, name, texture, role, hasResponded, totalEncounters, completedEncounters, numMembers, isLeader = GetLFGProposal()
	roleIconStr = ""
	if not hasResponded then
	for k=1, 5 do
		isLeader, role, level, responded, accepted, name, class = GetLFGProposalMember(k)
		if accepted then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",0,200,0,string.sub(role, 1, 1))
		else
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",200,0,0,string.sub(role, 1, 1))
		end
	end
			proposalExists, typeID, id, name, texture, role, hasResponded, totalEncounters, completedEncounters, numMembers, isLeader = GetLFGProposal()
			if role == "TANK" then role = "Tank" end
			if role == "DAMAGER" then role = "DPS" end
			if role == "HEALER" then role = "Healer" end
			dungeonInviteCurString = "You: " .. role ..   " - " .. roleIconStr
	end
end)



Broker_H3DC:RegisterEvent('LFG_PROPOSAL_UPDATE', function()
	proposalExists, typeID, id, name, texture, role, hasResponded, totalEncounters, completedEncounters, numMembers, isLeader = GetLFGProposal()
	roleIconStr = ""
	someoneDidntAccept = false
	for k=1, 5 do
		isLeader, role, level, responded, accepted, name, class = GetLFGProposalMember(k)
		if (responded == true) and (accepted == false) then someoneDidntAccept = true end
		if role then
		if accepted then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",0,200,0,string.sub(role, 1, 1))
		else
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",200,0,0,string.sub(role, 1, 1))
		end
		end
	end
	if (someoneDidntAccept == false) and (not (roleIconStr == "")) then
			proposalExists, typeID, id, name, texture, role, hasResponded, totalEncounters, completedEncounters, numMembers, isLeader = GetLFGProposal()
			if role == "TANK" then role = "Tank" end
			if role == "DAMAGER" then role = "DPS" end
			if role == "HEALER" then role = "Healer" end
			dungeonInviteCurString = "You: " .. role ..   " - " .. roleIconStr
	end
end)



Broker_H3DC:RegisterEvent('LFG_PROPOSAL_FAILED', function()
			H3DC_Object.text = string.format("|cff%02x%02x%02x%s",200,0,0,"Dungeon Group Failed")
			elapsed = 10
			TOTALTIME = 20
end)


Broker_H3DC:RegisterEvent('LFG_PROPOSAL_SUCCEEDED', function()
			H3DC_Object.text = string.format("|cff%02x%02x%02x%s",0,200,0,"Dungeon Group Succeeded!")
			elapsed = 10
			TOTALTIME = 20
end)


Broker_H3DC:RegisterEvent('LFG_QUEUE_STATUS_UPDATE', function()
	-- If we are queued, make the icon show what roles we have.
	hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime = GetLFGQueueStats()
	if hasData then
		roleIconStr = ""
		if tankNeeds == 1 then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",200,0,0,"T")
		else
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",200,0,0,"T")
		end

		if healerNeeds == 1 then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",200,0,0,"H")
		else
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s",0,200,0,"H")
		end

		if dpsNeeds == 1 then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s|cff%02x%02x%02x%s|cff%02x%02x%02x%s",0,200,0,"D",0,200,0,"D",200,0,0,"D")
		elseif dpsNeeds == 2 then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s|cff%02x%02x%02x%s|cff%02x%02x%02x%s",0,200,0,"D",200,0,0,"D",200,0,0,"D")
		elseif dpsNeeds == 3 then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s|cff%02x%02x%02x%s|cff%02x%02x%02x%s",200,0,0,"D",200,0,0,"D",200,0,0,"D")
		elseif dpsNeeds == 0 then
			roleIconStr = roleIconStr .. string.format("|cff%02x%02x%02x%s|cff%02x%02x%02x%s|cff%02x%02x%02x%s",0,200,0,"D",0,200,0,"D",0,200,0,"D")
		end


		H3DC_Object.text = roleIconStr
	end
end)






---Upon entering the module's object on the broker bar---
function H3DC_Object.OnEnter(self)

		 -- Turn the tooltip into a QTip tooltip to make formatting easier. --
	if (not db.showID) and (not db.showDate) then
	tooltip = LibQTip:Acquire("Broker_H3DungeonCooldowns", 3, "LEFT", "CENTER", "RIGHT")
	elseif ((db.showID) and (not db.showDate)) or ((not db.showID) and (db.showDate)) then
	tooltip = LibQTip:Acquire("Broker_H3DungeonCooldowns", 4, "LEFT", "CENTER", "CENTER","RIGHT")
	elseif db.showID and db.showDate then
	tooltip = LibQTip:Acquire("Broker_H3DungeonCooldowns", 5, "LEFT", "CENTER", "CENTER","CENTER","RIGHT")
	end
	 -- Setup hooks for the tooltip so it doesn't sit there forever. --
	tooltip:SmartAnchorTo(self)
	tooltip:Clear()

    self.tooltip = tooltip

	 -- Setup our fonts --
	tiphintFont = CreateFont("Broker_H3DungeonCooldownsFont-11")
	tiphintFont:SetFont(db.tooltipFont, db.tiphintSize*db.fontScale)

	textFont = CreateFont("Broker_H3DungeonCooldownsFont-12")
	textFont:SetFont(db.tooltipFont, db.textSize*db.fontScale)

	whitespaceFont = CreateFont("Broker_H3DungeonCooldownsFont-ws")
	whitespaceFont:SetFont(db.tooltipFont, (db.textSize/2)*db.fontScale)

	subheaderFont = CreateFont("Broker_H3DungeonCooldownsFont-13")
	subheaderFont:SetFont(db.tooltipFont, db.subheaderSize*db.fontScale)

	nameFont = CreateFont("Broker_H3DungeonCooldownsFont-14")
	nameFont:SetFont(db.tooltipFont, db.nameSize*db.fontScale)

	headerFont = CreateFont("Broker_H3DungeonCooldownsFont-15")
	headerFont:SetFont(db.tooltipFont, db.headerSize*db.fontScale)

	--- Set tooltip fonts to ours instead of using the regular game font. ---
	tooltip:SetHeaderFont(headerFont)
	tooltip:SetFont(textFont)

	if #(db.CharacterTbl[GetRealmName()]) > 1 then
		table.sort(db.CharacterTbl[GetRealmName()],function(a,b) return string.lower(a) < string.lower(b) end)
	end

	if #(db.RealmTbl) > 1 then
		table.sort(db.RealmTbl,function(a,b) return string.lower(a) < string.lower(b) end)
	end


	placeHolder = tooltip:AddLine(" ")
	tooltip:SetCell(placeHolder, 1, string.format("|TInterface\\Addons\\Broker_H3DungeonCooldowns\\icon:15:15:0:0|t H3 Dungeon Cooldowns (r%s) |TInterface\\Addons\\Broker_H3DungeonCooldowns\\icon:15:15:0:0|t",db.REVISION), headerFont, "CENTER", tooltip:GetColumnCount())


  	hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime = GetLFGQueueStats()
  	-- Dungeon Cooldown info (At request of ffcloud2000, fixed by spAnser) --
 	local random, deserter, now = GetLFGRandomCooldownExpiration(), GetLFGDeserterExpiration(), GetTime()
 	if ((random) or (deserter)) then
  		tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
  		-- Time until you can queue for a random again --
 		if random then
  			placeHolder = tooltip:AddLine(" ")
 			tooltip:SetCell(placeHolder, 1, "Random Queue - " .. SecondsToTime(random-now), headerFont, "CENTER", tooltip:GetColumnCount())
  		end

  		-- Time until you can queue again after leaving a group prematurely --
 		if deserter then
  			placeHolder = tooltip:AddLine(" ")
 			tooltip:SetCell(placeHolder, 1, "Dungeon Deserter - " .. SecondsToTime(deserter-now), headerFont, "CENTER", tooltip:GetColumnCount())
  		end

  		if GetLFGProposal() or hasData then return end
		tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
	end

	--- Dungeon invite info ---
	if GetLFGProposal() then
		tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
		proposalExists, typeID, id, name, texture, role, hasResponded, totalEncounters, completedEncounters, numMembers, isLeader = GetLFGProposal()

			-- Instance Name
		placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, name, headerFont, "CENTER", tooltip:GetColumnCount())

			-- Bosses Killed
			placeHolder = tooltip:AddLine(" ")
		if totalEncounters and completedEncounters then
			if totalEncounters == 0 then totalEncounters = "?" else totalEncounters = tostring(totalEncounters) end
			tooltip:SetCell(placeHolder, 1, string.format("%d/%s bosses killed",completedEncounters,totalEncounters), nameFont, "CENTER", tooltip:GetColumnCount())
		end
		tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
	end


	hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime = GetLFGQueueStats()
	-- CURRENT QUEUE INFO --
	if hasData then
			tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
			isLeader, isTank, isHealer, isDPS = GetLFGRoles()
		tankIcon_ = 	"|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:" .. db.headerSize*db.iconScale*db.fontScale .. ":" .. db.headerSize*db.iconScale*db.fontScale .. ":0:0:64:64:0:19:22:41|t"
		healerIcon_ = 	"|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:" .. db.headerSize*db.iconScale*db.fontScale .. ":" .. db.headerSize*db.iconScale*db.fontScale .. ":0:0:64:64:20:39:1:20|t"
		guideIcon_ = 	"|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:" .. db.headerSize*db.iconScale*db.fontScale .. ":" .. db.headerSize*db.iconScale*db.fontScale .. ":0:0:64:64:0:19:1:20|t"
		dpsIcon_ = 		"|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:" .. db.headerSize*db.iconScale*db.fontScale .. ":" .. db.headerSize*db.iconScale*db.fontScale .. ":0:0:64:64:20:39:22:41|t"

		rolesString = ""
		awtString = ""
		if isTank then
			rolesString = rolesString .. tankIcon_
		end
		if isHealer then
			rolesString = rolesString .. healerIcon_
		end
		if isDPS then
			rolesString = rolesString .. dpsIcon_
		end
		if isLeader then
			rolesString = rolesString .. guideIcon_
		end


		---Roles found---
		if tankNeeds == 1 then
			tankIcon = ""
		else
			tankIcon = tankIcon_
		end

		if healerNeeds == 1 then
			healerIcon = ""
		else
			healerIcon = healerIcon_
		end

		if dpsNeeds == 0 then
			dpsIcon1 = dpsIcon_
			dpsIcon2 = dpsIcon_
			dpsIcon3 = dpsIcon_
		elseif dpsNeeds == 1 then
			dpsIcon1 = dpsIcon_
			dpsIcon2 = dpsIcon_
			dpsIcon3 = ""
		elseif dpsNeeds == 2 then
			dpsIcon1 = dpsIcon_
			dpsIcon2 = ""
			dpsIcon3 = ""
		elseif dpsNeeds == 3 then
			dpsIcon1 = ""
			dpsIcon2 = ""
			dpsIcon3 = ""
		end


		placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, instanceName, headerFont, "CENTER", tooltip:GetColumnCount())

		placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, "Roles found", nameFont, "CENTER", tooltip:GetColumnCount())

		placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, string.format("|cff%02x%02x%02x%s|cff%02x%02x%02x%s|cff%02x%02x%02x%s|cff%02x%02x%02x%s|cff%02x%02x%02x%s",100,100,100,tankIcon,100,100,100,healerIcon,255,255,255,dpsIcon1,100,100,100,dpsIcon2,100,100,100,dpsIcon3), headerFont, "CENTER", tooltip:GetColumnCount())

		placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, "Queued As", nameFont, "CENTER", tooltip:GetColumnCount())

		placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, rolesString, headerFont, "CENTER", tooltip:GetColumnCount())

		placeHolder = tooltip:AddLine(" ")
		tooltip:SetCell(placeHolder, 1, "Time in Queue: " .. SecondsToTime(GetTime() - queuedTime), textFont, "LEFT", tooltip:GetColumnCount())

		if averageWait > 0 then
			placeHolder = tooltip:AddLine(" ")
			tooltip:SetCell(placeHolder, 1, "Average Wait: " .. SecondsToTime(averageWait), textFont, "LEFT", tooltip:GetColumnCount())

			if tankWait > 0 then
				awtString = awtString .. "  |TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:" .. db.textSize*db.iconScale*db.fontScale .. ":" .. db.textSize*db.iconScale*db.fontScale .. ":0:0:64:64:0:19:22:41|t" .. SecondsToTime(tankWait) .. "  "
			end

			if healerWait > 0 then
				awtString = awtString .. "  |TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:" .. db.textSize*db.iconScale*db.fontScale .. ":" .. db.textSize*db.iconScale*db.fontScale .. ":0:0:64:64:20:39:1:20|t" .. SecondsToTime(healerWait) .. "  "
			end

			if damageWait > 0 then
				awtString = awtString .. "  |TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES.blp:" .. db.textSize*db.iconScale*db.fontScale .. ":" .. db.textSize*db.iconScale*db.fontScale .. ":0:0:64:64:20:39:22:41|t" .. SecondsToTime(damageWait) .. "  "
			end

			placeHolder = tooltip:AddLine(" ")
			tooltip:SetCell(placeHolder, 1, awtString, textFont, "LEFT", tooltip:GetColumnCount())
		else
			placeHolder = tooltip:AddLine(" ")
			tooltip:SetCell(placeHolder, 1, "No average time avaliable.", textFont, "LEFT", tooltip:GetColumnCount())
		end

		tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
	end

	-- Tele in and out of the dungeon (for LFG groups) --
	isTank, isHeal, isDPS = UnitGroupRolesAssigned("player")
	inInstance, instanceType = IsInInstance()
	if isTank or isHeal or isDPS then -- Assume we are an LFD group if we have a role assigned
		placeHolder = tooltip:AddLine(" ")
		if inInstance and (instanceType == "party") then
			tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
			tooltip:SetCell(placeHolder, 1, "-Teleport out of the dungeon-", nameFont, "CENTER", tooltip:GetColumnCount())
			tooltip:SetLineScript(tooltip:GetLineCount(), "OnMouseDown", function() LFGTeleport(true) end)
		else
			tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
			tooltip:SetCell(placeHolder, 1, "-Teleport into the dungeon-", nameFont, "CENTER", tooltip:GetColumnCount())
			tooltip:SetLineScript(tooltip:GetLineCount(), "OnMouseDown", function() LFGTeleport(false) end)
		end
			tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
	end



	if (not db.showID) and (not db.showDate) then
	tooltip:AddHeader("Name","Difficulty","Time")
	elseif ((not db.showID) and (db.showDate)) then
	tooltip:AddHeader("Name","Difficulty","Time","Date")
	elseif ((db.showID) and (not db.showDate)) then
	tooltip:AddHeader("Name","Difficulty","Time","ID")
	elseif db.showID and db.showDate then
	tooltip:AddHeader("Name","Difficulty","Time","ID","Date")
	end



	--- Draw the cooldown info ---
	if db.AllToons then
		H3DC_SetupCooldowns(GetUnitName("player"),GetRealmName())
		for k, v in pairs(db.CharacterTbl[GetRealmName()]) do
			if (not (v == GetUnitName("player"))) then H3DC_SetupCooldowns(v,GetRealmName()) end
			if k == #(db.CharacterTbl[GetRealmName()]) then
				tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
			end
		end

	else
			H3DC_SetupCooldowns(GetUnitName("player"),GetRealmName())
			tooltip:AddSeparator(db.separatorSize, db.separatorCol[1], db.separatorCol[2], db.separatorCol[3])
	end

	placeHolder = tooltip:AddLine(" ")
	tooltip:SetCell(placeHolder, 1, string.format("|cffeda55f%s |cff%02x%02x%02x%s","Left-Click", 50,255,50," - Options menu."), tiphintFont, "LEFT", tooltip:GetColumnCount())
	placeHolder = tooltip:AddLine(" ")
	tooltip:SetCell(placeHolder, 1, string.format("|cffeda55f%s |cff%02x%02x%02x%s","Click Line", 50,255,50," - Report to chat."), tiphintFont, "LEFT", tooltip:GetColumnCount())
	placeHolder = tooltip:AddLine(" ")
	tooltip:SetCell(placeHolder, 1, string.format("|cffeda55f%s |cff%02x%02x%02x%s","Shift+Click Line", 50,255,50," - Extend current toon's lock."), tiphintFont, "LEFT", tooltip:GetColumnCount())



		--"Smart-Anchor" the tooltip to the object (H3DC_Object), aligning the tooltip
		--horizontally and vertically according to the objects position
		tooltip:SmartAnchorTo(self)


		---Show the tooltip, enable the mouse, and limit the tooltips height for those at small resolutions
		--(or those who have ALOT of characters :P)--
		tooltip:Show()
		tooltip:EnableMouse(true)
		tooltip:UpdateScrolling(db.tooltipHeight)
		tooltip:SetAutoHideDelay(0.1, self)


		RequestRaidInfo()
		pendingRequestInfo = true
end

--Update variables that need to be updated every "TOTALTIME" seconds (in this case, 5).

--
H3DC:SetScript('OnUpdate', function(self, elap)
	elapsed = elapsed + elap

		-- Display time left to accept
	if GetLFGProposal() and elapsed < 40 then
		H3DC_Object.text = dungeonInviteCurString .. "|r - " .. (40-math.floor(elapsed*10)/10) .. "s"
	end

	if not STARTUPCOMPLETE then
		H3DC_Object.text = "|TInterface\\Addons\\Broker_H3DungeonCooldowns\\icon:15:15:0:0|tLoading|TInterface\\Addons\\Broker_H3DungeonCooldowns\\icon:15:15:0:0|t"
		H3DC_Object.icon = ""
	end
	-- Stuff we only want to run every 'TOTALTIME' seconds.
	if elapsed < TOTALTIME then return end
	loopCount = loopCount + 1
	if loopCount == 3 then
		RequestRaidInfo()
		pendingRequestInfo = true
		loopCount = 0
	end


	STARTUPCOMPLETE = true
		H3DC_Object.icon = "Interface\\Addons\\Broker_H3DungeonCooldowns\\icon"
	hasData, leaderNeeds, tankNeeds, healerNeeds, dpsNeeds, instanceType, instanceName, averageWait, tankWait, healerWait, damageWait, myWait, queuedTime = GetLFGQueueStats()
	if (not hasData) and not(GetLFGProposal()) then
	if db.iconOnly == true then
		H3DC_Object.text = ""
	else
		H3DC_Object.text = "H3 DungeonCooldowns"
	end
	end

	exists = false
	for k, v in pairs(db.CharacterTbl[GetRealmName()]) do
	if v == GetUnitName("player") then exists = true end
	end
	if exists == false then
	db.CharacterTbl[GetRealmName()][#(db.CharacterTbl[GetRealmName()])+1] = GetUnitName("player")
	end
	exists = false
	for k,v in pairs(db.RealmTbl) do
	if v == GetRealmName() then exists = true end
	end
	if exists == false then
	db.RealmTbl[#(db.RealmTbl)+1] = GetRealmName()
	end

	elapsed = 0
end)


--Open the options menu or do other things when we click the object.
function H3DC_Object.OnClick(self, button)
if button == "LeftButton" then
--Use AceConfig's 'standalone' menu.
LibStub("AceConfigDialog-3.0"):Open("Broker_H3DungeonCooldowns")
end
end

